<form method="post" id="edit_form" name="edit_form">
  <div class="form-group row">
    <label class="col-4 text-right col-form-label" for="name">Nom</label> 
    <div class="col-7">
      <input id="name" name="name" type="text" class="form-control" required="required">
    </div>
  </div>
  <div class="form-group row">
    <label for="guest_type" class="col-4 text-right col-form-label">Moteur</label> 
    <div class="col-7">
      <select id="guest_type" name="guest_type" required="required" class="custom-select">
__LIST_ENGINES__
      </select>
    </div>
  </div>
  <div class="form-group row">
    <label for="file" class="col-4 text-right col-form-label">Fichier/Image</label>
    <div class="col-7">
      <select id="file" name="file" required="required" class="custom-select" aria-describedby="fileHelpBlock">
      </select>
      <span id="fileHelpBlock" class="form-text text-muted"></span>
    </div>
    <div class="col-1">
      <span id="newqcow2" role="button" data-toggle="tooltip" data-placement="right" title="Nouveau fichier QCow2" style="display: none;" data-original-title="Nouveau fichier QCow2" onclick="createqcow2()">
        <i class="fas fa-plus-circle fa-2x" style="vertical-align: -25%"></i>
      </span>
    </div>
  </div>
  <div class="form-group row">
    <label for="ram" class="col-4 text-right col-form-label">RAM</label>
    <div class="col-7">
      <input id="ram" name="ram" type="number" min="0" class="form-control" required="required" aria-describedby="ramHelpBlock">
      <span id="ramHelpBlock" class="form-text text-muted">Quantité de mémoire nécessaire/à réserver (en Mo)</span>
    </div>
  </div>
  <div id="cpu_div" class="d-none d-md-block">
    <div class="form-group row">
      <label for="cpu" class="col-4 text-right col-form-label">CPU</label>
      <div class="col-7">
        <input id="cpu" name="cpu" type="number" min="1" max="4" class="form-control" required="required" aria-describedby="cpuHelpBlock">
        <span id="cpuHelpBlock" class="form-text text-muted">Nombre de CPU</span>
      </div>
    </div>
  </div>
  <div class="form-group row">
    <label for="vol_size" class="col-4 text-right col-form-label">Taille disque</label>
    <div class="col-7">
      <input id="vol_size" name="vol_size" type="number" min="0" class="form-control" aria-describedby="vol_sizeHelpBlock" required="required">
      <span id="vol_sizeHelpBlock" class="form-text text-muted">Taille du disque nécessaire/à réserver (en Mo)</span>
    </div>
  </div>
  <div class="form-group row">
    <label for="lifetime" class="col-4 text-right col-form-label">Durée de vie</label>
    <div class="col-7">
      <input id="lifetime" name="lifetime" value="0" type="number" min="0" class="form-control" aria-describedby="lifetimeHelpBlock" required="required">
      <span id="lifetimeHelpBlock" class="form-text text-muted">Durée de vie de l'instance ( 0 = durée illimitée, sinon saisir la durée en minutes)</span>
    </div>
  </div>
  <div id="vnc_div" class="d-none d-md-block">
    <div class="form-group row">
      <label class="col-4 text-right">Console</label>
      <div class="col-7 text-left">
        <div class="custom-control custom-radio custom-control-inline">
          <input name="vnc" id="vnc_0" type="radio" class="custom-control-input" value="0" required="required">
          <label for="vnc_0" class="custom-control-label">Non</label>
        </div>
        <div class="custom-control custom-radio custom-control-inline">
          <input name="vnc" id="vnc_1" type="radio" class="custom-control-input" value="1" required="required">
          <label for="vnc_1" class="custom-control-label">Oui</label>
        </div>
      </div>
    </div>
  </div>
  <div id="kvm_engine" class="d-none d-md-block">
    <div class="form-group row">
      <label class="col-4 text-right">Pilote Virtio réseau</label>
      <div class="col-7 text-left">
        <div class="custom-control custom-radio custom-control-inline">
          <input name="net_virtio" id="net_virtio_0" type="radio" required="required" class="custom-control-input" value="0"> 
          <label for="net_virtio_0" class="custom-control-label">Non</label>
        </div>
        <div class="custom-control custom-radio custom-control-inline">
          <input name="net_virtio" id="net_virtio_1" type="radio" required="required" class="custom-control-input" value="1"> 
          <label for="net_virtio_1" class="custom-control-label">Oui</label>
        </div>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-4 text-right">Pilote Virtio SCSI</label>
      <div class="col-7 text-left">
        <div class="custom-control custom-radio custom-control-inline">
          <input name="scsi_virtio" id="scsi_virtio_0" type="radio" class="custom-control-input" value="0"> 
          <label for="scsi_virtio_0" class="custom-control-label">Non</label>
        </div>
        <div class="custom-control custom-radio custom-control-inline">
          <input name="scsi_virtio" id="scsi_virtio_1" type="radio" class="custom-control-input" value="1"> 
          <label for="scsi_virtio_1" class="custom-control-label">Oui</label>
        </div>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-4 text-right">Montage ISO</label>
      <div class="col-7 text-left">
        <div class="custom-control custom-radio custom-control-inline">
          <input name="mount_iso" id="mount_iso_0" type="radio" class="custom-control-input" value="0" required="required">
          <label for="mount_iso_0" class="custom-control-label">Non</label>
        </div>
        <div class="custom-control custom-radio custom-control-inline">
          <input name="mount_iso" id="mount_iso_1" type="radio" class="custom-control-input" value="1" required="required">
          <label for="mount_iso_1" class="custom-control-label">Oui</label>
        </div>
      </div>
    </div>
    <div class="form-group row">
      <label for="iso_path" class="col-4 text-right col-form-label">Chemin des fichiers ISO</label>
      <div class="col-7">
        <input id="iso_path" name="iso_path" type="text" class="form-control">
      </div>
    </div>
  </div>
  <div class="form-group row">
    <label class="col-4 text-right">Publié</label>
    <div class="col-7 text-left">
      <div class="custom-control custom-radio custom-control-inline">
        <input name="enable" id="enable_0" type="radio" class="custom-control-input" value="0"> 
        <label for="enable_0" class="custom-control-label">Non</label>
      </div>
      <div class="custom-control custom-radio custom-control-inline">
        <input name="enable" id="enable_1" type="radio" class="custom-control-input" value="1"> 
        <label for="enable_1" class="custom-control-label">Oui</label>
      </div>
    </div>
  </div>
  <div>
    <input type="hidden" id="tr" name="tr" value="__TOKEN__">
  </div>
  <div class="form-group row">
    <div class="offset-4 col-7">
      <a href="/admin/challenges" id="cancel" name="cancel" class="btn btn-outline-secondary">Cancel</a>
      <button name="submit_btn" type="submit" class="btn btn-primary">Soumettre</button>
    </div>
  </div>
</form>


<div id="qcow2_form" name="qcow2_form" class="card text-center" style="display: none;">
  <div class="card-body text-center">
    <h3>Créer un fichier disque QCOW2</h3>
    <div class="form-group row">
        <label for="file" class="col-4 text-right col-form-label">Nom du fichier</label>
        <div class="col-8">
          <input id="qcow2file" name="qcow2file" type="text" class="form-control" aria-describedby="fileQcow2HelpBlock" required="required">
          <span id="fileQcow2HelpBlock" class="form-text text-muted"></span>
        </div>
    </div>
    <div class="form-group row">
        <label for="disk" class="col-4 text-right col-form-label">Taille</label>
        <div class="col-8">
          <input id="disk" name="disk" type="number" min="1" class="form-control" required="required" aria-describedby="diskHelpBlock">
          <span id="diskHelpBlock" class="form-text text-muted">Taille du fichier (en Mo)</span>
        </div>
    </div>
    <div class="form-group row">
        <div class="offset-4 col-8">
            <button name="qcow2formcancel" type="button" onclick="toggleForm()" class="btn btn-outline-secondary">Cancel</button>
            <button name="qcow2formsubmit" type="button" onclick="qcow2formsubmit()" class="btn btn-primary">Créer</button>
        </div>
    </div>
  </div>
</div>

<script>
  $('input[name=mount_iso]').change(function(){
      var value = $('input[name=mount_iso]:checked').val();
      mount_iso_change(value);
  });

  $('#guest_type').change(function(){
      var value = $("#guest_type").val();
      guest_type_change(value);
  });

  $('#scsi_virtio_1').change(function(){
    alert('Attention, le pilote scsi_virtio est déconseillé avec le système de fichiers btrFS !');
  });

  $(document).ready(function() {
    // First time
    toggleForm();
    dictImages={};
    last_id_guest_type=null;
    current_value_file="__FILE__";
    $("#name").val("__NAME__");
    $("#file").val("__FILE__");
    $("#guest_type").val('__GUEST_TYPE__');
    $("#ram").val("__RAM__");
    $("#cpu").val("__CPU__");
    $("#vol_size").val("__VOL_SIZE__");
    $("input[name=net_virtio][value=__NET_VIRTIO__]").prop('checked', true);
    $("input[name=scsi_virtio][value=__SCSI_VIRTIO__]").prop('checked', true);
    $("input[name=vnc][value=__VNC__]").prop('checked', true);
    $("input[name=mount_iso][value=__MOUNT_ISO__]").prop('checked', true);
    $("#iso_path").val("__ISO_PATH__");
    $("#lifetime").val("__LIFETIME__");
    $("input[name=enable][value=__ENABLE__]").prop('checked', true);
    guest_type_change('__GUEST_TYPE__');
    mount_iso_change('__MOUNT_ISO__');
  });

  function guest_type_change(value) {
    value=(parseInt(value));
    queryImageslist(value); // update images list content
    if (value < 32) {
      // kvm engine
      $("#kvm_engine").addClass("d-md-block");
      $("#fileHelpBlock").html("Nom du fichier image disque au format qcow2 (ex: alpine.qcow2)");
      $("#newqcow2").show();
    }
    else {
      $("#kvm_engine").removeClass("d-md-block");
      $("input[name=net_virtio][value=0]").prop('checked', true);
      $("input[name=scsi_virtio][value=0]").prop('checked', true);
      $("input[name=mount_iso][value=0]").prop('checked', true);
      $("#newqcow2").hide();
    }
    if (value < 256) {
      // kvm, docker, lxc or lxd engine
      $("#cpu_div").addClass("d-md-block");
    } else {
      $("#cpu_div").removeClass("d-md-block");
    }
    switch (value) {
      case 32:
        // docker engine
      case 64:
        // lxc engine
      case 128:
        // lxd engine
        $("#fileHelpBlock").html("Nom de l'image (ex: apache2)")
        break;
      case 256:
        // archimulator engine
        $("#fileHelpBlock").html("Nom du fichier décrivant l'architecture (ex: external.yaml)")
        break;
    }
  }

  function mount_iso_change(value) {
    $('#iso_path').attr('disabled', parseInt(value) ? false : true );
  }

  function createqcow2() {
    // display form for create qcow2 file (and hide edit form)
    toggleForm("#qcow2_form", "#edit_form");
  }

  function qcow2formsubmit() {
        var filename=$('#qcow2file').val();
        var size=parseInt($('#disk').val());
        if (! filename.endsWith(".qcow2")) {
          filename+=".qcow2";
          $('#qcow2file').val(filename);
        }
        var checkregex_filename=filename.match(/[^A-Za-z0-9._-]/g);
        if (Array.isArray(checkregex_filename) && checkregex_filename.length > 0) {
            messageBoxWarning("Le nom du fichier n'est pas conforme. Caractères autorisés : A-Za-z0-9._-");
            return;
        }
        if (isNaN(size) || size<1) {
            messageBoxWarning("La taille du fichier doit être supérieure ou égale à 1");
            return;
        }
        block();
        $.ajax({
            url: '/api/createqcow2?name='+filename+'&size='+size,
            dataType: 'json',
            }).done(function (response) {
                unBlock();
                if (typeof response.success !== 'undefined') {
                    if (response.success) {
                        messageBoxInfo("Fichier '"+filename+"' créé.");
                        toggleForm();
                        // replace filename
                        current_value_file=filename;
                        queryImageslist(0, true);
                        // clear form qcow2
                        $('#qcow2file').val("");
                        $('#disk').val("");
                    } else
                        messageBoxWarning("Impossible de créer le fichier : " + response.message);
                }
        });
    };


  function toggleForm(show_form="#edit_form", hide_form="#qcow2_form") {
    $(show_form).show();
    $(hide_form).hide();
  }

  function updateSelectImagesList(id) {
    var custom_html="<option value=''></option>";
    var list=dictImages[id];
    for (var i = 0; i < list.length; i++) {
      var selected="";
      if (current_value_file===list[i])
        selected="selected='selected' ";
      custom_html+="<option "+selected+"value='"+list[i]+"'>"+list[i]+"</option>";
    }
    $('#file').html(custom_html); // update content
  }

  function queryImageslist(id=0, force=false) {
    id=id & 0b111100000;
    if (last_id_guest_type===id && ! force)
      return; // nothing to do (do not refresh)
    last_id_guest_type=id;
    var res=dictImages[id];
    if (typeof res === "undefined" || force) {
      // not in cache or forced
      $.ajax({
            url: '/api/getimageslist/'+id,
            dataType: 'json',
            }).done(function (response) {
                if (typeof response.success !== 'undefined') {
                    if (response.success) {
                        dictImages[id]=response.images;
                        updateSelectImagesList(id);
                    }
                }
        });
    } else
      updateSelectImagesList(id);

  }


</script>
